<?php
/**
 * Created by PhpStorm.
 * User: juanmacias
 * Date: 12/07/16
 * Time: 15:42
 */

namespace common\components\qamysqlconnection;


use yii\db\ActiveQuery;

class QueryBuilder extends \yii\db\mysql\QueryBuilder
{

    /**
     * @param \yii\db\Query $query
     * @param array $params
     * @return array
     * @throws \yii\db\Exception
     */
    public function build($query, $params = [])
    {
        $query = $query->prepare($this);

        $formOption="";
        $params_ar = empty($params) ? $query->params : array_merge($params, $query->params);

        foreach($params_ar as $key=>$value)
        {
            if ($key=="@FROM")
            {
                $formOption=$value;
            }
            else
            {
                $params[$key]=$value;
            }
        }



        $clauses = [
            $this->buildSelect($query->select, $params, $query->distinct, $query->selectOption),
            $this->buildFrom($query->from, $params),
            $formOption, // QaShops
            $this->buildJoin($query->join, $params),
            $this->buildWhere($query->where, $params),
            $this->buildGroupBy($query->groupBy),
            $this->buildHaving($query->having, $params),
        ];

        $sql = implode($this->separator, array_filter($clauses));
        $sql = $this->buildOrderByAndLimit($sql, $query->orderBy, $query->limit, $query->offset);

        $union = $this->buildUnion($query->union, $params);
        if ($union !== '') {
            $sql = "($sql){$this->separator}$union";
        }

        return [$sql, $params];
    }


}